################################################################################################
# ssdisable.ps1 -- This script will change the Values of "DeviceSelectiveSuspended" and
# "SelelctiveSuspendEnabled" under the restry key
# HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Enum\USB\"$VIDPIDs"\XXXXXXXXX\DeviceParameters
# from 1 to 0
################################################################################################

$VIDPIDList = "VID_8087&PID_0AAA", "VID_8087&PID_0025", "VID_8087&PID_0A2B"
$DevParameters = "Device Parameters"
$RootKey = "HKLM:\SYSTEM\CurrentControlSet\Enum\USB"
$ChildKey = ""
$DevInstance =""
$KeyPath = ""
$CurValue = 0


If (-NOT ([Security.Principal.WindowsPrincipal] [Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] "Administrator"))
{
    Write-Warning "Please re-run this script as an Administrator!"
    Break
}

# Search for a registry key and return 1 if it exists
function SearchRegistryKey($Key) {
    $regKey = Get-Item $key -ErrorAction SilentlyContinue;

    if(($regKey -eq $null) -or ($regKey.Length -eq 0)) {
        return 0;
    }
    else{
        return 1;
    }
}

$ChildKey = Get-ChildItem $RootKey -ErrorAction SilentlyContinue
$DevInstance = $ChildKey.PSChildName
$applyFlag = 0

foreach ($VIDPID in $VIDPIDList) {

  $KeyPath = "$RootKey\$VIDPID"

  $ret = SearchRegistryKey($KeyPath)
  
  # Found a device with this VID/PID  
  if ($ret -eq 1) {
    Write-Host "Found Key Path:: $KeyPath"
	
	$busKeyPathList = Get-ChildItem -Path $KeyPath
	
	foreach ($busKeyPath in $busKeyPathList ) {

	  Write-Host Get-ItemProperty -Path "Registry::$busKeyPath\$DevParameters"
      $CurValue = Get-ItemProperty -Path "Registry::$busKeyPath\$DevParameters" | Select-Object -ExpandProperty DeviceSelectiveSuspended -ErrorAction SilentlyContinue
      Write-Host "Current Value of $busKeyPath\DeviceSelectiveSuspended :: $CurValue"
      Write-Host "Changing the Value of DeviceSelectiveSuspended to 0..."
      Set-ItemProperty -Path "Registry::$busKeyPath\$DevParameters" -Name DeviceSelectiveSuspended -Value 0 -Type dword -ErrorAction SilentlyContinue

      $CurValue = Get-ItemProperty -Path "Registry::$busKeyPath\$DevParameters" | Select-Object -ExpandProperty SelectiveSuspendEnabled -ErrorAction SilentlyContinue
      Write-Host "Current Value of $busKeyPath\SelectiveSuspendEnabled :: $CurValue"
      Write-Host "Changing the Value of SelectiveSuspendEnabled to 0..."
      Set-ItemProperty -Path "Registry::$busKeyPath\$DevParameters" -Name SelectiveSuspendEnabled -Value 0 -Type dword -ErrorAction SilentlyContinue
	
	$applyFlag = 1
	}
  } 
  
}

if ($applyFlag -eq 0){
  Write-Host "No Intel Adapters Found"
}

Write-Host "Done!!!"
